package es.caib.signatura.client.swing;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.security.Security;
import java.security.cert.CertPath;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.Iterator;
import java.util.List;

import org.bouncycastle.jce.provider.BouncyCastleProvider;

import es.caib.signatura.api.ParsedCertificate;
import es.caib.signatura.api.Signer;
import es.caib.signatura.api.SignerFactory;
import es.caib.signatura.api.UpgradeNeededException;

public class CertificateParser {

	public CertificateParser(String file) throws UpgradeNeededException {
		
		
		
		SignerFactory sf=new SignerFactory();
		Signer s=sf.getSigner();
		
		
		CertificateFactory factory=null;
		Security.addProvider(new BouncyCastleProvider());
		try {
			factory = CertificateFactory.getInstance("X509","BC");
		
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		 CertPath cp=null;
			try {
				cp = factory.generateCertPath((List)factory.generateCertificates(new FileInputStream(file)));
			} catch (Throwable e) {
				e.printStackTrace();
				System.exit(1);
			}
			 List c=cp.getCertificates();
			 Iterator it = c.iterator();
			 int i=0;
			

			 
			while (it.hasNext()) {
				ParsedCertificate parsed=s.parseCertificate((X509Certificate)it.next());
				System.out.println(parsed.toString());
			}
		
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			new CertificateParser(args[0]);
		} catch (UpgradeNeededException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.exit(1);
		}

	}

}
