/**
 * 
 */
package es.caib.signatura.client.swing;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.bouncycastle.cms.CMSSignedData;
import org.bouncycastle.cms.SignerInformation;
import org.bouncycastle.cms.SignerInformationStore;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.util.Selector;
import org.bouncycastle.util.encoders.Base64;
import org.bouncycastle.x509.X509Store;


import com.lowagie.text.pdf.AcroFields;
import com.lowagie.text.pdf.PdfArray;
import com.lowagie.text.pdf.PdfDictionary;
import com.lowagie.text.pdf.PdfName;
import com.lowagie.text.pdf.PdfObject;
import com.lowagie.text.pdf.PdfReader;

/**
 * @author u91940
 *
 */
public class PDFDump {

	/**
	 * @throws FileNotFoundException 
	 * 
	 */
	public PDFDump(String filename) throws Exception {
		
	    InputStream pdfin=new FileInputStream(filename);
	    PdfReader pdfReader = new PdfReader(pdfin);
	    AcroFields acroFields = pdfReader.getAcroFields();
	    ArrayList signatureNames = acroFields.getSignatureNames();
	    
	    int i = 0;
	    for (i = 0; i < signatureNames.size(); i++) {
	    	
	        StringBuffer signers_filename = new StringBuffer();
	    	  
	    	String sigName = (String)signatureNames.get(i);
		    FileOutputStream fos = new FileOutputStream(filename+".pdf_dump.txt");

	        PdfDictionary pdfDictionary = acroFields.getSignatureDictionary(sigName);
	        Set keys=pdfDictionary.getKeys();
	        Iterator k_it=keys.iterator();
	        
	        while (k_it.hasNext()) {
	        	
	        	byte name[]=(byte [])((PdfName)k_it.next()).getBytes(); 
	        	fos.write(new String("\n** INICIO ***********************").getBytes());
	        	fos.write(new String(name).getBytes());
	        	fos.write(new String("\n** BODY ***********************\n").getBytes());
	        	
	        	if(pdfDictionary.get(new PdfName(name))!=null)
	        		if(pdfDictionary.get(new PdfName(name)) instanceof PdfArray){
	        			List list=((PdfArray)pdfDictionary.get(new PdfName(name))).getArrayList();
	        			for(int index=0;index<list.size();index++)
	        				fos.write(new String("\n"+((PdfObject)list.get(index))).getBytes());
	        		}else
	        			fos.write(pdfDictionary.get(new PdfName(name)).getBytes());
	        	
	        	fos.write(new String("\n** FIN **************************\n").getBytes());
	        }
	        
	        
	        PdfObject ob = pdfDictionary.get(PdfName.CONTENTS);      
	        CMSSignedData signedData = new CMSSignedData(ob.getBytes());  
	        X509Store certStore=signedData.getCertificates("Collection",new BouncyCastleProvider());
	        SignerInformationStore signerInfos=signedData.getSignerInfos();
	        ArrayList signers = new ArrayList(signerInfos.getSigners());
	        
	        Iterator it = signers.iterator();
	        while(it.hasNext()){
	        	
	        	SignerInformation   parallel_signer = (SignerInformation)it.next();
	        	Collection matches=certStore.getMatches(new CertSelector(parallel_signer.getSID().getSerialNumber()));
	        	
	        	signers_filename.append(matches.toArray());
	        	signers_filename.append("_");
	        }
	        
	        FileOutputStream pkcs_out_f=new FileOutputStream(filename+"_"+signers_filename.toString()+".p7s");
	        pkcs_out_f.write(signedData.getEncoded());
	        pkcs_out_f.close();
	      
	    } 
	    
	}
	

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			new PDFDump(args[0]);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.exit(1);
		}

	}

	public class CertSelector implements Selector{
 		BigInteger id=null;
		public CertSelector(BigInteger sid){
			this.id=sid;
		}
		public boolean match(Object arg0) {
			
			return true;
		}
		public Object clone(){
			return new CertSelector(id);
		};
	}	

}
