package es.caib.signatura.client.swing;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;

import org.bouncycastle.cms.CMSSignedData;
import org.bouncycastle.cms.SignerInformation;
import org.bouncycastle.cms.SignerInformationStore;

import com.lowagie.text.pdf.AcroFields;
import com.lowagie.text.pdf.PdfDictionary;
import com.lowagie.text.pdf.PdfName;
import com.lowagie.text.pdf.PdfObject;
import com.lowagie.text.pdf.PdfReader;

import es.caib.signatura.api.SignatureException;
import es.caib.signatura.api.Signer;

import es.caib.signatura.provider.impl.common.PDFSigner;

public class PruebasPDF {
	public static void main(String[] args) {
		//solo firma
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_NO.pdf",args[0],args[1],Signer.PDF_SIGN_POSITION_NONE);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		//estampado con código de barras
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_COD_TOP.pdf",args[0],args[1],Signer.PDF_SIGN_POSITION_TOP);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_COD_BOTTOM.pdf",args[0],args[1],Signer.PDF_SIGN_POSITION_BOTTOM);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_COD_LEFT.pdf",args[0],args[1],Signer.PDF_SIGN_POSITION_LEFT);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_COD_RIGHT.pdf",args[0],args[1],Signer.PDF_SIGN_POSITION_RIGHT);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		//estampado adobe
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_DEF_TOP_LEFT.pdf",args[0],args[1],Signer.PDF_SIGN_DEFAULT_SIGNATURE_APPERANCE | Signer.PDF_SIGN_POSITION_TOP | Signer.PDF_SIGN_POSITION_LEFT);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_DEF_TOP_RIGHTT.pdf",args[0],args[1],Signer.PDF_SIGN_DEFAULT_SIGNATURE_APPERANCE | Signer.PDF_SIGN_POSITION_TOP | Signer.PDF_SIGN_POSITION_RIGHT);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_DEF_BOTTOM_LEFT.pdf",args[0],args[1],Signer.PDF_SIGN_DEFAULT_SIGNATURE_APPERANCE | Signer.PDF_SIGN_POSITION_BOTTOM | Signer.PDF_SIGN_POSITION_LEFT);
		}catch(Exception e){
			e.printStackTrace();
		}
		
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_DEF_BOTTOM_RIGHT.pdf",args[0],args[1],Signer.PDF_SIGN_DEFAULT_SIGNATURE_APPERANCE | Signer.PDF_SIGN_POSITION_BOTTOM | Signer.PDF_SIGN_POSITION_RIGHT);
		}catch(Exception e){
			e.printStackTrace();
		}

	
		try{
			new PruebasPDF("documento_de_prueba.pdf","estampado_DEF_LAST.pdf",args[0],args[1],Signer.PDF_SIGN_PAGE_LAST | Signer.PDF_SIGN_DEFAULT_SIGNATURE_APPERANCE | Signer.PDF_SIGN_POSITION_BOTTOM | Signer.PDF_SIGN_POSITION_RIGHT);
		}catch(Exception e){
			e.printStackTrace();
		}

	}
	

	
	
	PruebasPDF(String in_filename,String out_filename,String certificate,String password,int position) throws Exception{
		InputStream in=new BufferedInputStream(new FileInputStream(in_filename));
		String contentType="application/signaturaTestNR";
		OutputStream pdfcopy=new FileOutputStream(out_filename); //new File(baseOutputFileName+inputFileName).canRead()
	    

		Signer signer= ClientSignerFactory.getSigner();
		signer.signPDF(in,pdfcopy, certificate, password, contentType,"http://www.caib.es",position,true);

		
		

	    in.close();
	    pdfcopy.close();
	    
	    
	}

}
