package es.caib.signatura.client.swing;
import javax.swing.JFrame;
import java.awt.Dimension;
import javax.swing.JButton;
import java.awt.Rectangle;
import java.awt.Font;
import javax.swing.JLabel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class SignaturaFrameOption extends JFrame 
{
  private JButton buttonSignar = new JButton();
  private JButton buttonSignarTS = new JButton();
  private JButton buttonSignarNR = new JButton();
  private JButton buttonVerificar = new JButton();
  private JButton buttonVerificarAPosterioriTimestamp = new JButton();
  private JButton buttonGenerarSMIME = new JButton();
  private JButton buttonEstamparPDF = new JButton();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private SignaturaClientProperties signaturaProperties;

  public SignaturaFrameOption()
  {
    try
    {
      signaturaProperties = new SignaturaClientProperties();
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }

  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(650, 400));
    this.setTitle(signaturaProperties.getProperty("appName"));

    /*
     *  Firma con certificado no reconocido
     */
    buttonSignarNR.setText(signaturaProperties.getProperty("signnr")); 
    buttonSignarNR.setBounds(new Rectangle(10, 105, 300, 40));
    buttonSignarNR.setFont(new Font("Arial", 1, 10));
    buttonSignarNR.addActionListener( new ActionListener () {
	public void actionPerformed(ActionEvent e) {
        buttonSignarNR_mouseClicked(e);
	}
	}
    		);

    /*
     *  Firma con certificado reconocido
     */
    buttonSignar.setText(signaturaProperties.getProperty("sign"));
    buttonSignar.setBounds(new Rectangle(10, 150, 300, 40));
    buttonSignar.setFont(new Font("Arial", 1, 10));
    buttonSignar.addActionListener( new ActionListener () {
	public void actionPerformed(ActionEvent e) {
        buttonSignar_mouseClicked(e);
	}
	}
    		);
    
    /*
     *  Firma con CR y sello de tiempo
     */
    buttonSignarTS.setText(signaturaProperties.getProperty("signts"));
    buttonSignarTS.setBounds(new Rectangle(10, 195, 300, 40));
    buttonSignarTS.setFont(new Font("Arial", 1, 10));
    buttonSignarTS.addActionListener( new ActionListener () {
	public void actionPerformed(ActionEvent e) {
        buttonSignarTS_mouseClicked(e);
	}
	}
    		);
    
    /*
     *  Verificar
     */
    buttonVerificar.setText(signaturaProperties.getProperty("verify"));
    buttonVerificar.setBounds(new Rectangle(340, 105, 120, 130));
    buttonVerificar.setFont(new Font("Arial", 1, 15));
    buttonVerificar.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonVerificar_mouseClicked(e);
        }
      });
    
    /*
     *  Verificar con timestamp a posteriori
     */
    buttonVerificarAPosterioriTimestamp.setText(signaturaProperties.getProperty("verifyAPosterioriTimestamp"));
    buttonVerificarAPosterioriTimestamp.setBounds(new Rectangle(490, 105, 140, 130));
    buttonVerificarAPosterioriTimestamp.setFont(new Font("Arial", 1, 15));
    buttonVerificarAPosterioriTimestamp.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonVerificarAPosterioriTimestamp_mouseClicked(e);
        }
      });

    /*
     *  PJR-inicio-30/09/2008 Generar SMIME
     */
    buttonGenerarSMIME.setText(signaturaProperties.getProperty("signsmime")); 
    buttonGenerarSMIME.setBounds(new Rectangle(10, 240, 300, 40));
    buttonGenerarSMIME.setFont(new Font("Arial", 1, 10));
    buttonGenerarSMIME.addActionListener( new ActionListener () {
	public void actionPerformed(ActionEvent e) {
		buttonGenerarSMIME(e);
	}
	}
    		);

    /*
     *  PJR-fin-30/09/2008 Generar SMIME
     */

    /*
     *  PJR-inicio-2/09/2008 Estampar PDF
     */
    buttonEstamparPDF.setText(signaturaProperties.getProperty("signpdf")); 
    buttonEstamparPDF.setBounds(new Rectangle(10, 285, 300, 40));
    buttonEstamparPDF.setFont(new Font("Arial", 1, 10));
    buttonEstamparPDF.addActionListener( new ActionListener () {
    	public void actionPerformed(ActionEvent e) {
    		buttonEstamparPDF(e);
    	}

	});

    /*
     *  PJR-fin-2/09/2008 Estampar PDF
     */    
    jLabel1.setText(signaturaProperties.getProperty("commonTitle"));
    jLabel1.setBounds(new Rectangle(20, 20, 330, 30));
    jLabel1.setFont(new Font("Arial", 1, 12));
    jLabel2.setText(signaturaProperties.getProperty("selectOption"));
    jLabel2.setBounds(new Rectangle(55, 70, 270, 20));
    this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(jLabel1, null);
    this.getContentPane().add(buttonVerificarAPosterioriTimestamp, null);
    this.getContentPane().add(buttonVerificar, null);
    this.getContentPane().add(buttonSignar, null);
    this.getContentPane().add(buttonSignarTS, null);
    this.getContentPane().add(buttonSignarNR, null);
    this.getContentPane().add(buttonGenerarSMIME, null);
    this.getContentPane().add(buttonEstamparPDF, null);
  }

  private void buttonSignar_mouseClicked(ActionEvent e)
  {
    openFrameSign("application/signaturaTest");
  }

private void openFrameSign(String contentType) {	
	final SignaturaFrameSign frameSign = new SignaturaFrameSign(contentType);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frameSign.getSize();
    if (frameSize.height > screenSize.height)
    {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width)
    {
      frameSize.width = screenSize.width;
    }
    // frameSign.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frameSign.setLocation(50,50);
    frameSign.addWindowListener(new WindowAdapter()
      {
        public void windowClosing(WindowEvent e)
        {
        //  System.exit(0);
	    frameSign.dispose ();
        }
      });
    frameSign.setVisible(true);
}

  private void buttonGenerarSMIME(ActionEvent e) {
	openFrameGenSMIME();
	
  }

  private void openFrameGenSMIME() {
		final SignaturaFrameSMIME frameSign = new SignaturaFrameSMIME();
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	    Dimension frameSize = frameSign.getSize();
	    if (frameSize.height > screenSize.height)
	    {
	      frameSize.height = screenSize.height;
	    }
	    if (frameSize.width > screenSize.width)
	    {
	      frameSize.width = screenSize.width;
	    }
	    frameSign.setLocation(50,50);
	    frameSign.addWindowListener(new WindowAdapter()
	      {
	        public void windowClosing(WindowEvent e)
	        {
	        	frameSign.dispose ();
	        }
	      });
	    frameSign.setVisible(true);
	
  }
  
  private void buttonEstamparPDF(ActionEvent e) {
		openFramePDF("application/signaturaTestPDF");
		
  }
  private void openFramePDF(String contentType) {
		final SignaturaFramePDF frameSign = new SignaturaFramePDF(contentType);
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	    Dimension frameSize = frameSign.getSize();
	    if (frameSize.height > screenSize.height)
	    {
	      frameSize.height = screenSize.height;
	    }
	    if (frameSize.width > screenSize.width)
	    {
	      frameSize.width = screenSize.width;
	    }
	    frameSign.setLocation(50,50);
	    frameSign.addWindowListener(new WindowAdapter()
	      {
	        public void windowClosing(WindowEvent e)
	        {
	        	frameSign.dispose ();
	        }
	      });
	    frameSign.setVisible(true);
	
  }
  
  private void buttonSignarTS_mouseClicked(ActionEvent e)
  {
    openFrameSign("application/signaturaTestTimeStamping");
  }

  private void buttonSignarNR_mouseClicked(ActionEvent e)
  {
    openFrameSign("application/signaturaTestNR");
  }

  private void buttonVerificar_mouseClicked(MouseEvent e)
  {
    final SignaturaFrameVerify frameVerify = new SignaturaFrameVerify();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frameVerify.getSize();
    if (frameSize.height > screenSize.height)
    {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width)
    {
      frameSize.width = screenSize.width;
    }
    frameVerify.setLocation(50,50);
    // frameVerify.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frameVerify.addWindowListener(new WindowAdapter()
      {
        public void windowClosing(WindowEvent e)
        {
          //System.exit(0);
	  frameVerify.dispose ();
        }
      });
    frameVerify.setVisible(true);
  }
  
  private void buttonVerificarAPosterioriTimestamp_mouseClicked(MouseEvent e)
  {
    final SignaturaFrameVerifyAPosterioriTimestamp frameVerifyAPosterioriTimestamp = new SignaturaFrameVerifyAPosterioriTimestamp();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frameVerifyAPosterioriTimestamp.getSize();
    if (frameSize.height > screenSize.height)
    {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width)
    {
      frameSize.width = screenSize.width;
    }
    frameVerifyAPosterioriTimestamp.setLocation(50,50);
    // frameVerify.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frameVerifyAPosterioriTimestamp.addWindowListener(new WindowAdapter()
      {
        public void windowClosing(WindowEvent e)
        {
          //System.exit(0);
	  frameVerifyAPosterioriTimestamp.dispose ();
        }
      });
    frameVerifyAPosterioriTimestamp.setVisible(true);
  }
   
  
}
