package es.caib.signatura.client.swing;

import java.awt.BorderLayout;
import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;
import java.awt.Rectangle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.OutputStream;
import java.util.Vector;

import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;

import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.ListSelectionModel;

import es.caib.signatura.api.Signature;
import es.caib.signatura.api.SignatureException;

public class SignaturaFrameSMIME extends JFrame {

	private static final long serialVersionUID = 1L;
	//  @jve:decl-index=0:
	private es.caib.signatura.api.Signer signer = null;  
	private SignaturaClientProperties signaturaProperties;
	private JPanel jContentPane = null;
	private JFileChooser chooser = new JFileChooser();
	private ImageIcon imageOpen = new ImageIcon(SignaturaFrameSign.class.getResource("openfile.gif"));
	private JButton buttonHelp = null;
	private JToolBar jToolBar =  null;
	private JPanel jPanel_up = null;
	private JTextField jTextField_inputPath = null;
	private JLabel jLabel_inputPathText = null;
	private JButton jButton_openFile = null;
	private JScrollPane jScrollPane_signsList = null;
	private JList jList_signs = null;
	private JButton jButton_addSign = null;
	private JButton jButton_removeSign = null;
	private JButton jButton_generateSMIME = null;
	private JLabel jLabel_signs_list = null;
	private JLabel jLabel_outputPath = null;
	private JTextField jTextField_outputPath = null;
	private JButton jButton_openFile2 = null;
	
	class MutableList extends JList {
	    /**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		MutableList() {
		super(new DefaultListModel());
	    }
	    DefaultListModel getContents() {
		return (DefaultListModel)getModel();
	    }
	}

	
	public SignaturaFrameSMIME() throws HeadlessException {
		super();
	    try
	    {
	      signaturaProperties = new SignaturaClientProperties();
	    }
	    catch(Exception e)
	    {
	      e.printStackTrace();
	    }


		initialize();
		initSignature();
	}

	public SignaturaFrameSMIME(GraphicsConfiguration arg0) {
		super(arg0);
		initialize();
	}

	public SignaturaFrameSMIME(String arg0) throws HeadlessException {
		super(arg0);
		initialize();
	}

	public SignaturaFrameSMIME(String arg0, GraphicsConfiguration arg1) {
		super(arg0, arg1);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		
		this.setSize(511, 310);
		this.setContentPane(getJContentPane());
		this.setTitle(signaturaProperties.getProperty("signsmime"));
		
		
	    

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJToolBar(), BorderLayout.NORTH);
			jContentPane.add(getJPanel_up(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

  private void buttonHelp_mouseClicked(MouseEvent e)
  {
    showMessageBox("about");
  }

  private void buttonOpenFile_mouseClicked(MouseEvent e)
  {
    int returnVal = chooser.showOpenDialog(SignaturaFrameSMIME.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = chooser.getSelectedFile();
            //This is where a real application would open the file.
            jTextField_inputPath.setText(file.getAbsolutePath());
        }
  }

  private void buttonOpenFile2_mouseClicked(MouseEvent e)
  {
    int returnVal = chooser.showOpenDialog(SignaturaFrameSMIME.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = chooser.getSelectedFile();
            //This is where a real application would open the file.
            jTextField_outputPath.setText(file.getAbsolutePath());
        }
  }
  private void buttonAddSign_mouseClicked(MouseEvent e)
  {
    int returnVal = chooser.showOpenDialog(SignaturaFrameSMIME.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = chooser.getSelectedFile();
            //This is where a real application would open the file.
           ((MutableList)jList_signs).getContents().addElement(file.getAbsolutePath());
            
            
        }
  }

  private void buttonRemoveSign_mouseClicked(MouseEvent e)
  {
	  int selected[]=jList_signs.getSelectedIndices();
	  if(selected!=null && selected.length!=0){
		  int i=0;
		  for(i=0;i<selected.length;i++){
			  ((MutableList)jList_signs).getContents().removeElementAt(selected[i]);
		  }
	  }
  }

  

  
  private void generateSMIME() {
	    
	  DefaultListModel signList=((DefaultListModel)((MutableList)jList_signs).getContents());
	  	if(signList==null || signList.size()==0){
	  		showMessageError("signsmimeemptylist");
	  		return;
	  	}

	  	if(jTextField_inputPath.getText().equals("")){
	  		showMessageError("signsmimeemptyinput");
	  		return;
	  	}

	  	if( jTextField_outputPath.getText().equals("")){
	  		showMessageError("signsmimeemptyoutput");
	  		return;
	  	}
	  	
	  	ObjectInputStream signatureStream = null;
	    OutputStream outStream=null;
	    FileInputStream fis = null;
	    try {
			fis=new FileInputStream (jTextField_inputPath.getText());
		} catch (FileNotFoundException e2) {
			showMessageError("signsmimeemnoexistsinput");
			e2.printStackTrace();
		}
		
		try {
			outStream=new FileOutputStream(jTextField_outputPath.getText());
		} catch (FileNotFoundException e2) {
			e2.printStackTrace();
		}
	    Vector signatureData = new Vector();
	   
	  
	    int i;
	    for(i=0;i<signList.size();i++){
		    try 
		    {
		      signatureStream = new ObjectInputStream (new FileInputStream(signList.get(i).toString()));
		      signatureData.add((Signature) signatureStream.readObject());
		    }  
		    catch (FileNotFoundException fe)
		    {
		      	fe.printStackTrace();
		        showMessageError(signList.get(i).toString(),"signatureFileNotFound");
		        return;
		    }
		    catch (IOException ioe)
		    {
		      	ioe.printStackTrace();
		        showMessageError(signList.get(i).toString(),"signatureFileNotOpen");
		        return;
		    } 
		    catch (ClassNotFoundException sde) 
		    {
		      	sde.printStackTrace();
		        showMessageError(signList.get(i).toString(),"signatureDataError");
		        return;
		  	}
		    finally
		    {
		  		try {
		  			signatureStream.close();
		  		}catch(Exception e1){
		  			
		  		}
		  	}
	    }
	    
	    //una vez leíadas las firmas, generamos el SMIME
	    try {
	    	
	    	if(signatureData.size()==1){
	    		signer.generateSMIME(fis, (Signature)signatureData.get(0), outStream);
	    	}else{
	    		signer.generateSMIMEParalell(fis, (Signature [] )signatureData.toArray(new Signature[signatureData.size()]), outStream);
	    	}
		} catch (IOException e1) {
			
			e1.printStackTrace();
		} catch (SignatureException e1) {

			e1.printStackTrace();
		}finally{
			try {
				fis.close();
				outStream.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	    
		
  }
  
  private void showMessageBox(String message)
  {
    JOptionPane.showMessageDialog(null, signaturaProperties.getProperty(message), "Govern Balear: Signatura Digital", JOptionPane.INFORMATION_MESSAGE);
  }

  private void showMessageError(String message)
  {
    JOptionPane.showMessageDialog(null, signaturaProperties.getProperty(message), "Govern Balear: Signatura Digital", JOptionPane.ERROR_MESSAGE);
  }

  private void showMessageError(String userDefinedMessage,String message)
  {
    JOptionPane.showMessageDialog(null,signaturaProperties.getProperty(message) +"\n"+ userDefinedMessage, "Govern Balear: Signatura Digital", JOptionPane.ERROR_MESSAGE);
  }

private JButton getButtonHelp(){
	if(buttonHelp==null){
		buttonHelp=new JButton();
	    buttonHelp.setToolTipText("About");
	    buttonHelp.setText("Sobre...");
	    buttonHelp.addMouseListener(new java.awt.event.MouseAdapter()
	      {
	        public void mouseClicked(MouseEvent e)
	        {
	          buttonHelp_mouseClicked(e);
	        }
	      });
	}
	return buttonHelp;
}
/**
 * This method initializes jToolBar	
 * 	
 * @return javax.swing.JToolBar	
 */
private JToolBar getJToolBar() {
    if(jToolBar==null){
    	jToolBar=new JToolBar();

		jToolBar.add(getButtonHelp());
    }
	return jToolBar;
}



/**
 * This method initializes jPanel_up	
 * 	
 * @return javax.swing.JPanel	
 */
private JPanel getJPanel_up() {
	if (jPanel_up == null) {
		jLabel_outputPath = new JLabel();
		jLabel_outputPath.setBounds(new Rectangle(15, 165, 392, 16));
		jLabel_outputPath.setText("Seleccione el fichero donde se guardara el S/MIME resultante");
		jLabel_signs_list = new JLabel();
		jLabel_signs_list.setBounds(new Rectangle(14, 45, 392, 18));
		jLabel_signs_list.setText("Seleccione las firmas del documento");
		jLabel_inputPathText = new JLabel();
		jLabel_inputPathText.setBounds(new Rectangle(13, 4, 393, 15));
		jLabel_inputPathText.setText("Seleccione el fichero con el que se generará el SMIME");
		jPanel_up = new JPanel();
		jPanel_up.setLayout(null);
		jPanel_up.add(getJTextField_inputPath(), null);
		jPanel_up.add(jLabel_inputPathText, null);
		jPanel_up.add(getJButton_openFile(), null);
		jPanel_up.add(getJScrollPane_signsList(), null);
		jPanel_up.add(getJButton_addSign(), null);
		jPanel_up.add(getJButton_removeSign(), null);
		jPanel_up.add(getJButton_generateSMIME(), null);
		jPanel_up.add(jLabel_signs_list, null);
		jPanel_up.add(jLabel_outputPath, null);
		jPanel_up.add(getJTextField_outputPath(), null);
		jPanel_up.add(getJButton_openFile2(), null);
	}
	return jPanel_up;
}

/**
 * This method initializes jTextField_inputPath	
 * 	
 * @return javax.swing.JTextField	
 */
private JTextField getJTextField_inputPath() {
	if (jTextField_inputPath == null) {
		jTextField_inputPath = new JTextField();
		jTextField_inputPath.setBounds(new Rectangle(13, 18, 394, 19));
	}
	return jTextField_inputPath;
}

/**
 * This method initializes jButton_openFile	
 * 	
 * @return javax.swing.JButton	
 */
private JButton getJButton_openFile() {
	if (jButton_openFile == null) {
		jButton_openFile = new JButton();
		jButton_openFile.setBounds(new Rectangle(419, 16, 63, 20));
		jButton_openFile.setText("open");
		jButton_openFile.setIcon(imageOpen);
		jButton_openFile.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e) {
				buttonOpenFile_mouseClicked(e);	
			}}
		);		
	}
	return jButton_openFile;
}

/**
 * This method initializes jScrollPane_signsList	
 * 	
 * @return javax.swing.JScrollPane	
 */
private JScrollPane getJScrollPane_signsList() {
	if (jScrollPane_signsList == null) {
		jScrollPane_signsList = new JScrollPane();
		jScrollPane_signsList.setBounds(new Rectangle(14, 64, 394, 92));
		jScrollPane_signsList.setViewportView(getJList_signs());
	}
	return jScrollPane_signsList;
}



/**
 * This method initializes jList_signs	
 * 	
 * @return javax.swing.JList	
 */
private JList getJList_signs() {
	if (jList_signs == null) {
		jList_signs = new MutableList();
		jList_signs.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
	}
	return jList_signs;
}

/**
 * This method initializes jButton_addSign	
 * 	
 * @return javax.swing.JButton	
 */
private JButton getJButton_addSign() {
	if (jButton_addSign == null) {
		jButton_addSign = new JButton();
		jButton_addSign.setBounds(new Rectangle(420, 65, 64, 20));
		jButton_addSign.setText("+");
		jButton_addSign.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e) {
				buttonAddSign_mouseClicked(e);	
			}}
		);
	}
	return jButton_addSign;
}

/**
 * This method initializes jButton_removeSign	
 * 	
 * @return javax.swing.JButton	
 */
private JButton getJButton_removeSign() {
	if (jButton_removeSign == null) {
		jButton_removeSign = new JButton();
		jButton_removeSign.setBounds(new Rectangle(420, 87, 64, 20));
		jButton_removeSign.setText("-");
		jButton_removeSign.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e) {
				buttonRemoveSign_mouseClicked(e);	
			}}
		);
	}
	return jButton_removeSign;
}


/**
 * This method initializes jButton_generateSMIME	
 * 	
 * @return javax.swing.JButton	
 */
private JButton getJButton_generateSMIME() {
	if (jButton_generateSMIME == null) {
		jButton_generateSMIME = new JButton();
		jButton_generateSMIME.setBounds(new Rectangle(125, 213, 173, 17));
		jButton_generateSMIME.setText("Generar S/MIME");
		jButton_generateSMIME.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e) {
				try{
					generateSMIME();
				}catch(Exception ex){
					ex.printStackTrace();
				}
				}
			});
	}
	return jButton_generateSMIME;
}

private void initSignature()
{
	
	signer = ClientSignerFactory.getSigner();
	
	if (signer == null)
	{
		showMessageError("NoProvider");
		return;
	}
}

/**
 * This method initializes jTextField_outFilePath	
 * 	
 * @return javax.swing.JTextField	
 */
private JTextField getJTextField_outputPath() {
	if (jTextField_outputPath == null) {
		jTextField_outputPath = new JTextField();
		jTextField_outputPath.setBounds(new Rectangle(15, 180, 393, 20));
		
	}
	return jTextField_outputPath;
}

/**
 * This method initializes jButton_openFile2	
 * 	
 * @return javax.swing.JButton	
 */
private JButton getJButton_openFile2() {
	if (jButton_openFile2 == null) {
		jButton_openFile2 = new JButton();
		jButton_openFile2.setBounds(new Rectangle(417, 179, 63, 20));
		jButton_openFile2.setText("open");
		jButton_openFile2.setIcon(new ImageIcon(SignaturaFrameSign.class.getResource("openfile.gif")));
		jButton_openFile2.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e) {
				buttonOpenFile2_mouseClicked(e);
			}
		});
	}
	return jButton_openFile2;
}

}  //  @jve:decl-index=0:visual-constraint="10,10"