package es.caib.signatura.client.swing;
import es.caib.signatura.api.*;

import javax.swing.JFrame;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;
import java.awt.Dimension;
import java.awt.Rectangle;
import javax.swing.JList;
import java.awt.event.MouseEvent;
import javax.swing.JScrollPane;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JFileChooser;
import java.io.File;
import javax.swing.*;
import java.io.*;
import java.security.UnrecoverableKeyException;
import java.awt.Font;




public class SignaturaFrameSign extends JFrame 
{
  private ImageIcon imageHelp = new ImageIcon(SignaturaFrameSign.class.getResource("help.gif"));
  private ImageIcon imageClose = new ImageIcon(SignaturaFrameSign.class.getResource("closefile.gif"));
  private ImageIcon imageOpen = new ImageIcon(SignaturaFrameSign.class.getResource("openfile.gif"));
  private JButton buttonHelp = new JButton();
  private JButton buttonOpenFile = new JButton();
  private JToolBar toolBar = new JToolBar();
  private JPanel panelCenter = new JPanel();
  private BorderLayout layoutMain = new BorderLayout();
  private JList list = new JList();
  private JScrollPane scrollPanel = new JScrollPane(list);
  private JTextField passwordText = new JPasswordField();
  private JLabel passwordLabel = new JLabel();
  private JTextField fileTextField = new JTextField();
  private JButton signarBtn = new JButton();
  private JTextField sigFileTextField = new JTextField();
  private JFileChooser chooser = new JFileChooser();
  private JButton buttonSaveFile = new JButton();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JLabel jLabel3 = new JLabel();
  private SignaturaClientProperties signaturaProperties;
  private es.caib.signatura.api.Signer signer = null;
  private String contentType;

  public SignaturaFrameSign(String contentType)
  {
    try
    {
      this.contentType = contentType;
      signaturaProperties = new SignaturaClientProperties();
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }

  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(layoutMain);
    panelCenter.setLayout(null);

    scrollPanel.setBounds(new Rectangle(20, 25, 400, 100));
    passwordText.setBounds(new Rectangle(20, 150, 135, 20));
    passwordLabel.setText(signaturaProperties.getProperty("insertPassword"));
    passwordLabel.setBounds(new Rectangle(20, 130, 195, 15));
    fileTextField.setBounds(new Rectangle(20, 205, 440, 20));
    signarBtn.setText(signaturaProperties.getProperty("sign"));
    signarBtn.setBounds(new Rectangle(210, 300, 85, 25));
    signarBtn.setFont(new Font("Arial", 1, 14));
    signarBtn.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          signarBtn_mouseClicked(e);
        }
      });
    sigFileTextField.setBounds(new Rectangle(20, 255, 440, 20));
    buttonSaveFile.setToolTipText(signaturaProperties.getProperty("openFile"));
    buttonSaveFile.setIcon(imageClose);
    buttonSaveFile.setBounds(new Rectangle(460, 255, 30, 25));
    buttonSaveFile.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonSaveFile_mouseClicked(e);
        }
      });
    
    jLabel1.setText(signaturaProperties.getProperty("selectDocumentFileName"));
    jLabel1.setBounds(new Rectangle(20, 185, 430, 20));
    jLabel2.setText(signaturaProperties.getProperty("insertSignatureFileName"));
    jLabel2.setBounds(new Rectangle(20, 235, 440, 15));
    jLabel3.setText(signaturaProperties.getProperty("selectCert"));
    jLabel3.setBounds(new Rectangle(20, 5, 240, 20));
    this.setSize(new Dimension(507, 397));
    this.setTitle(signaturaProperties.getProperty("appName")+"("+contentType+")");
    buttonOpenFile.setToolTipText(signaturaProperties.getProperty("openFile"));
    buttonOpenFile.setIcon(imageOpen);
    buttonOpenFile.setBounds(new Rectangle(460, 200, 30, 25));
    buttonOpenFile.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonOpenFile_mouseClicked(e);
        }
      });
    buttonHelp.setToolTipText("About");
    buttonHelp.setText("Sobre...");
    buttonHelp.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonHelp_mouseClicked(e);
        }
      });
    toolBar.add(buttonHelp);
    this.getContentPane().add(toolBar, BorderLayout.NORTH);
    this.getContentPane().add(panelCenter, BorderLayout.CENTER);
    panelCenter.add(jLabel3, null);
    panelCenter.add(jLabel2, null);
    panelCenter.add(jLabel1, null);
    panelCenter.add(buttonSaveFile, null);
    panelCenter.add(sigFileTextField, null);
    panelCenter.add(signarBtn, null);
    panelCenter.add(fileTextField, null);
    panelCenter.add(passwordLabel, null);
    panelCenter.add(passwordText, null);
    scrollPanel.getViewport().add(list, null);
    panelCenter.add(scrollPanel, null);
    panelCenter.add(buttonOpenFile, null);
  
    initSignature();



  }

  private void initSignature()
  {
	
	signer = ClientSignerFactory.getSigner();
	
	if (signer == null)
	{
		showMessageError("NoProvider");
		return;
	}
    String[] certList = {signaturaProperties.getProperty("certListNotFound")};
    list.setListData(certList);
    signarBtn.setEnabled(false);
  
    
	try {
  		certList = signer.getCertList(contentType);
    }
    catch (SignaturePrivKeyException ex)
    {
      showMessageError("certListNotFound");
      ex.printStackTrace(); 
      return;
    }
    catch (SignatureCertNotFoundException cex)
    {
      showMessageError("certListNotFound");
      cex.printStackTrace(); 
      return;
    }

		if (certList!=null){
      list.setListData(certList); 
		}
  
    list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    signarBtn.setEnabled(true);

  }




  private void buttonOpenFile_mouseClicked(MouseEvent e)
  {
    int returnVal = chooser.showOpenDialog(SignaturaFrameSign.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = chooser.getSelectedFile();
            //This is where a real application would open the file.
            fileTextField.setText(file.getAbsolutePath());
        }
  }

  private void buttonSaveFile_mouseClicked(MouseEvent e)
  {
        int returnVal = chooser.showSaveDialog(SignaturaFrameSign.this);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = chooser.getSelectedFile();
            //This is where a real application would open the file.
            sigFileTextField.setText(file.getAbsolutePath());
        }
  }

  private void signarBtn_mouseClicked(MouseEvent e)
  {

    if (!signarBtn.isEnabled())
    {
      return;
    }
    String certName = (String)list.getSelectedValue();

    if (certName==null)
    {
      showMessageBox("selectCert");
      return;
    }

    /* Permetem validar sense contrassenya.
   if (passwordText.getText().equalsIgnoreCase(""))
    {
      showMessageBox("insertPassword");
      return;
    }
    */
    if (fileTextField.getText().equalsIgnoreCase(""))
    {
      showMessageBox("selectDocumentFile");
      return;
    }
    if (sigFileTextField.getText().equalsIgnoreCase(""))
    {
      showMessageBox("insertSignatureFile");
      return;
    }

 

    int result;
    if (fileExists(this.sigFileTextField.getText()))
    {
      result = JOptionPane.showConfirmDialog(null, signaturaProperties.getProperty("signatureFileExists") ,signaturaProperties.getProperty("signatureFileExistsTitle"),JOptionPane.YES_NO_OPTION);
      if (result == JOptionPane.NO_OPTION)
      {
        this.sigFileTextField.setText("");
        return;
      }
    }



    Signature signatureData = null;

    try{
     signatureData = signer.sign(fileTextField.getText(),certName, passwordText.getText(), 
     		contentType);
    }
    catch (FileNotFoundException fe)
    {
      showMessageError("documentFileNotFound");
      return;
    }
    catch (IOException io)
    {
      showMessageError("networkError");
      return;
    }
    catch (Exception se)
    {
    	se.printStackTrace();
    	Throwable root = se;
    	while (root.getCause() != null && root.getCause() != root)
    		root = root.getCause ();
        JOptionPane.showMessageDialog(null, signaturaProperties.getProperty("signatureError")+se.toString(), 
        		"Govern Balear: Signatura Digital", JOptionPane.ERROR_MESSAGE);
    	return;
    }

    try{
      // Generar la firma
      ObjectOutputStream oout = new ObjectOutputStream(new FileOutputStream(sigFileTextField.getText()));
      oout.writeObject(signatureData);
      oout.close();
      // Generar el MIME Original
      FileInputStream fis = new FileInputStream (fileTextField.getText());
      FileOutputStream fos = new FileOutputStream(sigFileTextField.getText()+".slc");
      signer.generateSMIME(fis, signatureData, fos);
      fis.close();
      fos.close();
    }
    catch (FileNotFoundException fe)
    {
      showMessageError("signatureFileSaveError");
      return;
    }
    catch (IOException io)
    {
      showMessageError("signatureFileSaveError");
      return;
    }

    showMessageBox("signatureOK");

    
  }


  private void showMessageBox(String message)
  {
    JOptionPane.showMessageDialog(null, signaturaProperties.getProperty(message), "Govern Balear: Signatura Digital", JOptionPane.INFORMATION_MESSAGE);
  }

  private void showMessageError(String message)
  {
    JOptionPane.showMessageDialog(null, signaturaProperties.getProperty(message), "Govern Balear: Signatura Digital", JOptionPane.ERROR_MESSAGE);
  }


  private boolean fileExists(String fileName) {
	   
		boolean fileOK = false;
		File file = new File(fileName);
		//Comprobamos que el fichero existe
		if (file.exists()) {
		  //Comprobamos que es realmente un fichero, no un directorio
		  if (file.isFile()) {
			fileOK = true;
		  } 
	   }
	   return fileOK;
	 }

  private void buttonHelp_mouseClicked(MouseEvent e)
  {
    showMessageBox("about");
  }




}