package es.caib.signatura.client.swing;
import es.caib.signatura.api.*;

import javax.swing.JFrame;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToolBar;
import javax.swing.ListSelectionModel;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.awt.Font;
import javax.swing.JToggleButton.ToggleButtonModel;

public class SignaturaFrameVerify extends JFrame 
{
  private ImageIcon imageHelp = new ImageIcon(SignaturaFrameVerify.class.getResource("help.gif"));
  private ImageIcon imageClose = new ImageIcon(SignaturaFrameVerify.class.getResource("closefile.gif"));
  private ImageIcon imageOpen = new ImageIcon(SignaturaFrameVerify.class.getResource("openfile.gif"));
  private JButton buttonHelp = new JButton();
  private JToolBar toolBar = new JToolBar();
  private JPanel panelCenter = new JPanel();
  private BorderLayout layoutMain = new BorderLayout();
  private JButton buttonOpenFile = new JButton();
  private JTextField fileTextField = new JTextField();
  private JButton buttonOpenSigFile = new JButton();
  private JTextField sigFileTextField = new JTextField();
  private JButton buttonVerify = new JButton();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JFileChooser chooser = new JFileChooser();
  private JLabel jLabel3 = new JLabel();
  private SignaturaClientProperties signaturaProperties;
  private JButton btnSigData = new JButton();
  private es.caib.signatura.api.Signer signer = null;

  public SignaturaFrameVerify()
  {
    try
    {
      signaturaProperties = new SignaturaClientProperties();
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }

  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(layoutMain);
    panelCenter.setLayout(null);
    buttonOpenFile.setToolTipText(signaturaProperties.getProperty("openFile"));
    buttonOpenFile.setIcon(imageOpen);
    buttonOpenFile.setBounds(new Rectangle(470, 70, 30, 25));
    buttonOpenFile.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonOpenFile_mouseClicked(e);
        }
      });
    fileTextField.setBounds(new Rectangle(30, 70, 440, 20));
    buttonOpenSigFile.setToolTipText(signaturaProperties.getProperty("openFile"));
    buttonOpenSigFile.setIcon(imageOpen);
    buttonOpenSigFile.setBounds(new Rectangle(470, 130, 30, 25));
    buttonOpenSigFile.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonOpenSigFile_mouseClicked(e);
        }
      });
    sigFileTextField.setBounds(new Rectangle(30, 130, 440, 20));
    buttonVerify.setText(signaturaProperties.getProperty("verify"));
    buttonVerify.setBounds(new Rectangle(220, 175, 100, 35));
    buttonVerify.setFont(new Font("Arial", 1, 14));
    buttonVerify.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonVerify_mouseClicked(e);
        }
      });
    jLabel1.setText(signaturaProperties.getProperty("selectDocumentToVerify"));
    jLabel1.setBounds(new Rectangle(30, 45, 385, 25));
    jLabel2.setText(signaturaProperties.getProperty("selectSignatureFileName"));
    jLabel2.setBounds(new Rectangle(30, 115, 355, 15));
    jLabel3.setText(signaturaProperties.getProperty("title"));
    jLabel3.setBounds(new Rectangle(30, 10, 320, 15));
    jLabel3.setFont(new Font("Arial", 1, 13));
    btnSigData.setBounds(new Rectangle(505, 130, 30, 25));
    btnSigData.setIcon(imageHelp);
    btnSigData.setToolTipText(signaturaProperties.getProperty("signatureInformation"));
    btnSigData.setModel(new ToggleButtonModel());
    btnSigData.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          btnSigData_mouseClicked(e);
        }
      });
    this.setSize(new Dimension(555, 283));
    this.setTitle(signaturaProperties.getProperty("appName"));
    buttonHelp.setToolTipText("About");
    buttonHelp.setText("Sobre...");
    buttonHelp.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          buttonHelp_mouseClicked(e);
        }
      });
    toolBar.add(buttonHelp);
    this.getContentPane().add(toolBar, BorderLayout.NORTH);
    panelCenter.add(btnSigData, null);
    panelCenter.add(jLabel2, null);
    panelCenter.add(jLabel1, null);
    panelCenter.add(buttonVerify, null);
    panelCenter.add(sigFileTextField, null);
    panelCenter.add(buttonOpenSigFile, null);
    panelCenter.add(fileTextField, null);
    panelCenter.add(buttonOpenFile, null);
    panelCenter.add(jLabel3, null);
    this.getContentPane().add(panelCenter, BorderLayout.CENTER);
    
  }
  
  private void initSignature()
  {
	
	signer = ClientSignerFactory.getSigner();
	if (signer == null)
	{
		showMessageError("NoProvider");
		return;
	}

  }

  
  private void buttonOpenSigFile_mouseClicked(MouseEvent e)
  {

    int returnVal = chooser.showOpenDialog(SignaturaFrameVerify.this);
    if (returnVal == JFileChooser.APPROVE_OPTION) 
    {
      File file = chooser.getSelectedFile();     
      sigFileTextField.setText(file.getAbsolutePath());
    }
  }

 private void buttonOpenFile_mouseClicked(MouseEvent e)
  {
    int returnVal = chooser.showOpenDialog(SignaturaFrameVerify.this);
    if (returnVal == JFileChooser.APPROVE_OPTION) 
    {
      File file = chooser.getSelectedFile();     
      fileTextField.setText(file.getAbsolutePath());
    }

  }

  private void buttonVerify_mouseClicked(MouseEvent e)
  {

    ObjectInputStream signatureStream = null;
    InputStream in = null;
    Signature signatureData = null;
    boolean result = false;
    
    
    if (fileTextField.getText().equalsIgnoreCase(""))
    {
      showMessageBox("selectVerifyFile");
      return;
    }

    if (sigFileTextField.getText().equalsIgnoreCase(""))
    {
      showMessageBox("selectSignatureFile");
      return;
    }

    try 
    {
      signatureStream = new ObjectInputStream (
      			new FileInputStream(sigFileTextField.getText()));
      signatureData = (Signature) signatureStream.readObject();
      try{
    	  signatureData.verify();
      }catch(Exception signatureException){
    	  signatureException.printStackTrace();
      }
      signatureStream.close();
      //------------------------------------------
      //Convertimos el fichero de entrada en un Inputstream
      in = new FileInputStream(fileTextField.getText());
      initSignature();
    }
    catch (FileNotFoundException fe)
    {
    	fe.printStackTrace();
      showMessageError("signatureFileNotFound");
      return;
    }
    catch (IOException ioe)
    {
    	ioe.printStackTrace();
      showMessageError("signatureFileNotOpen");
      return;
    } catch (ClassNotFoundException sde) {
    	sde.printStackTrace();
       showMessageError("signatureDataError");
       return;
	}


    try
    {
    	//TODO: mirar si esto esta bien
      result = signer.verify(fileTextField.getText(), signatureData);
    }
    catch (FileNotFoundException fe)
    {
      fe.printStackTrace();
      showMessageError("documentFileNotOpen");
      return;
    }
    catch (SignatureProviderException spe)
    {
      spe.printStackTrace();
      showMessageError("initProviderError");
      return;
    }
    catch (IOException ie)
    {
      ie.printStackTrace();
      showMessageError("networkError");
      return;
    }
    catch (SignatureVerifyException se)
    {
      se.printStackTrace();
      showMessageError("verifyError");
      return;
    }

    if (result)
    {
      showMessageBox("verifyOK"); 
    }
    else
    {
      showMessageError("verifyNotOK");
    }
      




  
  }





  private void showMessageBox(String message)
  {
    JOptionPane.showMessageDialog(null, signaturaProperties.getProperty(message), signaturaProperties.getProperty("appName"), JOptionPane.INFORMATION_MESSAGE);
  }

  private void showMessageError(String message)
  {
    JOptionPane.showMessageDialog(null, signaturaProperties.getProperty(message), signaturaProperties.getProperty("appName"), JOptionPane.ERROR_MESSAGE);
  }

  private void buttonHelp_mouseClicked(MouseEvent e)
  {
    showMessageBox("about");
  }

  private void btnSigData_mouseClicked(MouseEvent e)
  {
    ObjectInputStream signatureStream = null;
    Signature signatureData = null;
    boolean result = false;
    String caName = "";
    String commonName = "";
     
    SignerFactory sf = new SignerFactory();
	Signer sigTradise = ClientSignerFactory.getSigner();

    if (sigFileTextField.getText().equalsIgnoreCase(""))
    {
      showMessageBox("selectSignatureFile");
      return;
    }

    try 
    {
      signatureStream = new ObjectInputStream (
      			new FileInputStream(sigFileTextField.getText()));
      signatureData = (Signature) signatureStream.readObject();      
      
      signatureStream.close();
    }
    catch (FileNotFoundException fe)
    {
      showMessageError("signatureFileNotFound");
      return;
    }
    catch (IOException ioe)
    {
      showMessageError("signatureFileNotOpen");
      return;
    }
    catch (ClassNotFoundException sde)
    {
      showMessageError("signatureDataError");
      return;
    }
    String segell;
    try {
      if (signatureData.getDate()!=null) {
		segell = signatureData.getDate().toGMTString();
      } else {
    	segell = "No tiene";
      }
	} catch (SignatureTimestampException e1) {
		segell = "No tiene";
	}
    caName = signatureData.getCertCaName();
    commonName = signatureData.getCertSubjectCommonName();
    String message = signaturaProperties.getProperty("caName") + ": " + caName + "\n";
    message = message + signaturaProperties.getProperty("commonName") + ": " + commonName;
    message = message + ", Sello de tiempo: "+segell;
    JOptionPane.showMessageDialog(null, message, signaturaProperties.getProperty("appName"), JOptionPane.INFORMATION_MESSAGE);
  }
}